package cokr.xit.fims.crdn.web;

import java.util.List;
import java.util.Map;

import javax.annotation.Resource;

import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.servlet.ModelAndView;

import cokr.xit.base.code.CommonCode;
import cokr.xit.base.web.ApplicationController;
import cokr.xit.fims.crdn.Crdn;
import cokr.xit.fims.crdn.CrdnQuery;
import cokr.xit.fims.crdn.service.CrdnService;
import cokr.xit.fims.crdn.service.CrdnStngService;

/**단속 관리 서비스 웹 컨트롤러.<br />
 * {웹 컨텍스트}/crdn/crdn06 로 접근할 수 있다.
 * @author leebj
 */
public class Crdn06Controller extends ApplicationController {

	public static final String CLASS_URL = "/crdn/crdn06";

	public class METHOD_URL {
		public static final String
		crackdownManagementMain = "/010/main.do",
		getCrackdownList = "/010/list.do"
		;
	}

	@Resource(name="crdnService")
	private CrdnService crdnService;

	@Resource(name="crdnStngService")
	private CrdnStngService crdnStngService;

	/** 단속 관리 메인화면을 연다.
	 * @return fims/crdn/crdn06010-main
	 */
	public ModelAndView crackdownManagementMain() {
		ModelAndView mav = new ModelAndView();
		mav.setViewName("fims/crdn/crdn06010-main");
		mav.addObject("pageName", "crdn06010-main");

		Map<String, List<CommonCode>> commonCodes = getCodesOf("FIM002", "FIM003", "FIM005", "FIM010", "FIM022", "FIM026",
				"FIM034", "FIM054");
		mav.addObject("FIM003List", commonCodes.get("FIM003"));
		mav.addObject("FIM005List", commonCodes.get("FIM005"));
		mav.addObject("FIM010List", commonCodes.get("FIM010"));
		mav.addObject("FIM054List", commonCodes.get("FIM054"));
		addCodes(commonCodes, mav, "FIM002", "FIM003", "FIM010", "FIM022", "FIM026", "FIM034");
		return mav;
	}

	/**단속자료 목록을 조회한다.<br />
	 * {@link CrdnService#getCrackdownList(CrdnQuery)} 참고
	 * @param query 단속자료 목록 조회 조건
	 * @return jsonView
	 */
	public ModelAndView getCrackdownList(CrdnQuery query) {
		setFetchSize(query);
		return setCollectionInfo(new ModelAndView("jsonView"), crdnService.getCrackdownList(query),"");
	}

	/**지정한 단속 ID에 해당하는 단속 대장를 제거한다.
	 * @param crdnID 단속 ID
	 * @return jsonView
	 * <pre><code> {
	 *     "affected": 저장된 정보수
	 *     "saved": 저장되었으면 true, 그렇지 않으면 false
	 * }</code></pre>
	 */
	@PostMapping(name = "단속 대장 제거", value = "/010/remove.do")
	public ModelAndView removeCrackdown(Crdn crdn) {
		boolean saved = false;
		String retMessage = crdnService.removeCrackdown(crdn);

		if (retMessage.contains("[S]")) {
			saved = true;
		} else {
			saved = false;
		}

		return new ModelAndView("jsonView")
				.addObject("saved", saved)
				.addObject("retMessage", retMessage);
	}

}
